// SPI controlled SID emulator
// By Koen van Vliet (Keoni29)
// Emulator written by
// Last revision 28-12-2013
// Check for updates frequently on: http://www.8times8.host56.com/

// Look at README.txt for build instructions and calculator software.

#include <SPI.h>
#include <SID.h>
 
SID mySid;

void setup (void)
{
  mySid.begin();                  // Start the SID soundchip emulator
  SPCR |= _BV(SPE);               // Enable hardware SPI (slave mode)
  SPI.setBitOrder(LSBFIRST);      // Least significant byte first
  SPI.setDataMode(SPI_MODE2);     // Clock normal HIGH. Grab byte on falling edge
}

void loop (void){
  static byte addr;
  while (bitRead(SPSR,7) == 0){}      // Wait until a byte is received over SPI
  addr = SPDR;                        // Grab register address
  while (bitRead(SPSR,7) == 0){}      // Wait until a byte is received over SPI
  if (mySid.get_register(addr)!=SPDR) // If register value is different from current value
    mySid.set_register(addr,SPDR);    // Update the register with the new value
}
